package com.github.tmdb.wrapper;

import java.util.List;
import org.apache.log4j.Logger;
import org.codehaus.jackson.annotate.JsonAnySetter;
import org.codehaus.jackson.annotate.JsonProperty;

import com.github.tmdb.model.AlternativeTitle;

/**
 *
 * @author Stuart
 */
public class WrapperAlternativeTitles {
    /*
     * Logger
     */

    private static final Logger LOGGER = Logger.getLogger(WrapperAlternativeTitles.class);
    /*
     * Properties
     */
    @JsonProperty("id")
    private int id;
    @JsonProperty("titles")
    private List<AlternativeTitle> titles;

    public int getId() {
        return id;
    }

    public List<AlternativeTitle> getTitles() {
        return titles;
    }

    public void setId(int id) {
        this.id = id;
    }

    public void setTitles(List<AlternativeTitle> titles) {
        this.titles = titles;
    }

    /**
     * Handle unknown properties and print a message
     * @param key
     * @param value
     */
    @JsonAnySetter
    public void handleUnknown(String key, Object value) {
        StringBuilder sb = new StringBuilder();
        sb.append("Unknown property: '").append(key);
        sb.append("' value: '").append(value).append("'");
        LOGGER.warn(sb.toString());
    }
}
