package com.github.tmdb.wrapper;

import org.apache.log4j.Logger;
import org.codehaus.jackson.annotate.JsonAnySetter;
import org.codehaus.jackson.annotate.JsonProperty;

import com.github.tmdb.model.TmdbConfiguration;

/**
 *
 * @author Stuart
 */
public class WrapperConfig {
    /*
     * Logger
     */

    private static final Logger LOGGER = Logger.getLogger(WrapperConfig.class);
    /*
     * Properties
     */
    @JsonProperty("images")
    private TmdbConfiguration tmdbConfiguration;

    public TmdbConfiguration getTmdbConfiguration() {
        return tmdbConfiguration;
    }

    public void setTmdbConfiguration(TmdbConfiguration tmdbConfiguration) {
        this.tmdbConfiguration = tmdbConfiguration;
    }
    
    /**
     * Handle unknown properties and print a message
     * @param key
     * @param value
     */
    @JsonAnySetter
    public void handleUnknown(String key, Object value) {
        StringBuilder sb = new StringBuilder();
        sb.append("Unknown property: '").append(key);
        sb.append("' value: '").append(value).append("'");
        LOGGER.warn(sb.toString());
    }

}
