package com.github.tmdb.wrapper;

import java.util.List;
import org.apache.log4j.Logger;
import org.codehaus.jackson.annotate.JsonAnySetter;
import org.codehaus.jackson.annotate.JsonProperty;

import com.github.tmdb.model.Keyword;

/**
 *
 * @author Stuart
 */
public class WrapperMovieKeywords {
    /*
     * Logger
     */

    private static final Logger LOGGER = Logger.getLogger(WrapperMovieKeywords.class);
    /*
     * Properties
     */
    @JsonProperty("id")
    private int id;
    @JsonProperty("keywords")
    private List<Keyword> keywords;

    //<editor-fold defaultstate="collapsed" desc="Getter methods">
    public int getId() {
        return id;
    }

    public List<Keyword> getKeywords() {
        return keywords;
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="Setter methods">
    public void setId(int id) {
        this.id = id;
    }

    public void setKeywords(List<Keyword> keywords) {
        this.keywords = keywords;
    }
    //</editor-fold>

    /**
     * Handle unknown properties and print a message
     * @param key
     * @param value
     */
    @JsonAnySetter
    public void handleUnknown(String key, Object value) {
        StringBuilder sb = new StringBuilder();
        sb.append("Unknown property: '").append(key);
        sb.append("' value: '").append(value).append("'");
        LOGGER.warn(sb.toString());
    }
}
